<?php
namespace Teknisa\PLA\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;

class ListaPratoEquivalente extends \Teknisa\GER\Controllers\TeknisaCrud {
    protected $dataSourceName = "pla00001_lista_de_pratos_equivalentes";
    protected $environment;
    protected $util;
    protected $connection;
    protected $dataSourceManager;
    
    public function __construct($crudService, $parameterBag, $environment, $util, $connection, $dataSourceManager) {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->environment = $environment;
        $this->util = $util;
        $this->connection = $connection;
        $this->dataSourceManager = $dataSourceManager;
        parent::__construct($crudService, $parameterBag);
    }

    public function savePratos(DTO\Request\Row $request, DTO\Response $response) {
        try {
            $this->dataSourceName = "pratorelac";
            $row = $request->getRow();
            $this->connection->beginTransaction();
            $duplicatedRows = array();    
           
            foreach ($row["pratos"] as $row) {
                try { 
                    $dataSet = new DataSet($this->dataSourceName, array($row));
                    $newRequest = new DTO\Request\DataSet($dataSet, "", "", "");
                    $rows = $this->crudService->getRowsToSave($newRequest, $this->dataSourceName);
                    $this->crudService->save($this->dataSourceName, $rows);
                } catch(\Exception $e) {
                    
                    if ($e->getMessage() == "Impossível adicionar. Registro já existe.") {
                        array_push($duplicatedRows, $row['NMPRATO']);
                    } else {
                           throw $e;
                    }
                }
            }

            $this->connection->commit();
            if (!empty($duplicatedRows)) {
                $response->addDataSet(new DataSet("errorDuplicated", $duplicatedRows)); 
            } 
        }catch(\Exception $e) {
             $this->connection->rollback();
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
}